import java.awt.BorderLayout;
import java.awt.Container;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.WindowEvent;
import java.awt.event.WindowListener;

import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;


public class SLAnalyzeDialog extends JDialog implements ActionListener ,WindowListener,Runnable {
	//̎
	static final int WORK_ANALYZE=0;
	static final int WORK_CHECK_QUESTION=1;
	static final int WORK_CHECK_ANSWER_STRACT=2;
	//
	SLPanel puzzle;
	SLAnalyze analyze;
	//
	JLabel messageLabel=new JLabel(LST.V[LST.ANSWER]+" "+LST.V[LST.QUESTION]+" "+LST.V[LST.CHECK]+"...");	//TCŶ
	JButton cancelButton=new JButton();
	//
	Thread analyzeThread;	//w@gp̕ʃXbh
	int workType;			//̎
	int tmpAnalyzeLevel;
	SLData tmpPuzzleData;
	//m}XtO̓f[^̗ケŕێ
	boolean ignoreFlag;
	//-------------------------------------------------------------
	//
	//-------------------------------------------------------------
	public SLAnalyzeDialog(SLPanel panel){
		super();
		setModal(true);		//ʃXbh쒆̓[_ɂĕύXh
		//
		JPanel labelPanel=new JPanel();
		labelPanel.add(messageLabel);
		JPanel buttonPanel=new JPanel();
		buttonPanel.add(cancelButton);
		//Reig
		Container cp=getContentPane();
		cp.add(labelPanel,BorderLayout.CENTER);
		cp.add(buttonPanel,BorderLayout.SOUTH);
		//
		setLanguageText();
		//TCYiŏ\傫̂őł͕svj
		pack();
		//
		setLocationRelativeTo(null);	//ʂ̐^񒆂ɕ\
		//
		cancelButton.addActionListener(this);
		addWindowListener(this);
		//
		puzzle=panel;
		analyze=new SLAnalyze(panel);
	}
	//t@CύX𔽉f
	//-------------------------------------------------------------
	public void setLanguageText(){
		cancelButton.setText(LST.V[LST.CANCEL]);
	}
	//-------------------------------------------------------------
	//m}XtO
	//-------------------------------------------------------------
	public void setIgnoreFlag(boolean ignore){
		ignoreFlag=ignore;
	}
	//-------------------------------------------------------------
	//3
	//-------------------------------------------------------------
	public void analyzePuzzle(SLData data,int level){
		if(level<=4){
			//w@gȂȂ炠܂莞Ԃ͂Ȃ
			analyze.analyze(data, level,ignoreFlag);
		}else{
			//w@gp͎Ԃ̂ŕʃXbh
			workType=WORK_ANALYZE;
			tmpPuzzleData=data;
			tmpAnalyzeLevel=level;
			analyzeThread=new Thread(this);
			analyzeThread.start();
			//
			setTitle(LST.V[LST.ANALYZE]);
			if(level==5){
				messageLabel.setText(LST.V[LST.SINGLE]+" "+LST.V[LST.ASSUMPTION]+"...");
			}else{
				messageLabel.setText(LST.V[LST.MULTIPLE]+" "+LST.V[LST.ASSUMPTION]+"...");
			}
			setVisible(true);
		}
	}
	public void checkQuestion(SLData data){
		//
		workType=WORK_CHECK_QUESTION;
		tmpPuzzleData=data;
		//tmpAnalyzeLevel=6;
		analyzeThread=new Thread(this);
		analyzeThread.start();
		//
		setTitle(LST.V[LST.QUESTION]+" "+LST.V[LST.CHECK]);
		messageLabel.setText(LST.V[LST.MULTIPLE]+" "+LST.V[LST.ASSUMPTION]+"...");
		setVisible(true);
	}
	public void checkAnswerStract(SLData data){
		//
		workType=WORK_CHECK_ANSWER_STRACT;
		tmpPuzzleData=data;
		//tmpAnalyzeLevel=6;
		analyzeThread=new Thread(this);
		analyzeThread.start();
		//
		setTitle(LST.V[LST.ANSWER]+" "+LST.V[LST.QUESTION]+" "+LST.V[LST.CHECK]);
		messageLabel.setText(LST.V[LST.MULTIPLE]+" "+LST.V[LST.ASSUMPTION]+"...");
		setVisible(true);
	}
	//-------------------------------------------------------------
	//͗p̕ʃXbh
	//-------------------------------------------------------------
	public void run() {
		if(workType==WORK_ANALYZE){
			//ʏ̉
			analyze.analyze(tmpPuzzleData, tmpAnalyzeLevel,ignoreFlag);
		}else{
			//蔻E𔻒
			analyze.masterMessageFlag=false;		//OPFw@̊Ԃ̓bZ[W\Ȃ
			int tmpLineSum=SLContinueLine.lineSum;	//OQFNXϐޔĂ
			int tmpLoopSum=SLContinueLine.loopSum;
			//ĉ𓚏i̎ɃNXϐ͏Ăj
			SLData questionData=tmpPuzzleData.clone();
			questionData.formatLine();
			//ōʉ͂{
			boolean result=analyze.analyze(questionData, 6,false);		//ł͐m}X͖Ȃ
			//͒~̂łȂ
			if(!analyze.stopFlag){
				if(result){
					if(workType==WORK_CHECK_QUESTION){
						if(checkFinished(questionData)){	//
							JOptionPane.showMessageDialog(puzzle,LST.V[LST.SINGLE]+" "+LST.V[LST.ANSWER],LST.V[LST.QUESTION]+" "+LST.V[LST.CHECK],JOptionPane.INFORMATION_MESSAGE);
						}else{								//G[		(܂͖m̐)
							JOptionPane.showMessageDialog(puzzle,LST.V[LST.CONTRADICTION]+"\ni"+LST.V[LST.OR]+" "+LST.V[LST.ER_05]+"j",LST.V[LST.QUESTION]+" "+LST.V[LST.CHECK],JOptionPane.ERROR_MESSAGE);
						}
					}else if(workType==WORK_CHECK_ANSWER_STRACT){		//Ȃ
						JOptionPane.showMessageDialog(puzzle,LST.V[LST.CORRECT]+"\n"+LST.V[LST.AND]+" "+LST.V[LST.SINGLE]+" "+LST.V[LST.ANSWER],LST.V[LST.ANSWER]+" "+LST.V[LST.QUESTION]+" "+LST.V[LST.CHECK],JOptionPane.INFORMATION_MESSAGE);
					}
				}else{
					if(workType==WORK_CHECK_QUESTION){		//Ȃ
						JOptionPane.showMessageDialog(puzzle,LST.V[LST.MULTIPLE]+" "+LST.V[LST.ANSWER],LST.V[LST.QUESTION]+" "+LST.V[LST.CHECK],JOptionPane.ERROR_MESSAGE);
					}else if(workType==WORK_CHECK_ANSWER_STRACT){		//
						JOptionPane.showMessageDialog(puzzle,LST.V[LST.CORRECT]+"\n"+LST.V[LST.BUT]+" "+LST.V[LST.MULTIPLE]+" "+LST.V[LST.ANSWER],LST.V[LST.ANSWER]+" "+LST.V[LST.QUESTION]+" "+LST.V[LST.CHECK],JOptionPane.INFORMATION_MESSAGE);
					}
				}
			}
			//
			SLContinueLine.lineSum=tmpLineSum;		//㏈PFNXϐɖ߂
			SLContinueLine.loopSum=tmpLoopSum;
			analyze.masterMessageFlag=true;			//㏈QFbZ[W\悤ɖ߂
		}
		//
		setVisible(false);
	}
	private boolean checkFinished(SLData data){	//͌ɊĂ邩
		//}Xm
		for(int h=0;h<data.height;h++){
			for(int w=0;w<data.width;w++){
				if(data.cellNum[w][h]==SLData.CELL_ANY){
					return false;
				}
			}
		}
		//G[
		if(data.errors.size()!=0){	return false;	}
		//E[v
		if(SLContinueLine.lineSum!=1){	return false;	}
		if(SLContinueLine.loopSum!=1){	return false;	}
		/*
		if(data.checkNolineNumber()){	return false; }	//[v1.4]Pƃ[vɁu͂ꐔvi[v1.7]Œuj
		*/
		if(data.checkLinelessNumber()){	return false;	}	//[v1.7]Pƃ[vɁus̐v
		//Ă
		return true;
	}
	//-------------------------------------------------------------
	//{^Cxg
	//-------------------------------------------------------------
	public void actionPerformed(ActionEvent e) {
		if(e.getSource()==cancelButton){
			analyze.stopFlag=true;	//͒~
		}
	}
	//-------------------------------------------------------------
	//EBhECxg
	//-------------------------------------------------------------
	public void windowActivated(WindowEvent arg0) {
	}
	public void windowClosed(WindowEvent arg0) {
	}
	public void windowClosing(WindowEvent e) {
		analyze.stopFlag=true;	//͒~
	}
	public void windowDeactivated(WindowEvent arg0) {
	}
	public void windowDeiconified(WindowEvent arg0) {
	}
	public void windowIconified(WindowEvent arg0) {
	}
	public void windowOpened(WindowEvent arg0) {
	}
}
