import java.awt.Color;
import java.awt.Point;
import java.util.ArrayList;
import java.util.StringTokenizer;

import javax.swing.JOptionPane;

public class SLData implements Cloneable{
	//}X
	static final int CELL_NONE=-1;
	static final int CELL_ALL=4;
	static final int CELL_ANY=5;
	//
	static final int LINE_NONE=-1;
	static final int LINE_BLANK=0;
	static final int LINE_EXIST=1;
	//
	static final int DIR_UP=0;
	static final int DIR_DOWN=1;
	static final int DIR_RIGHT=2;
	static final int DIR_LEFT=3;
	static final int DIR_ALL=4;
	//_ɂ̏oiz̓YɎgj
	static final int POINT_RIGHT_UP=0;
	static final int POINT_RIGHT_DOWN=1;
	static final int POINT_ALL=2;
	//
	int width,height;
	int[][] cellNum;
	int[][] lineHor;
	int[][] lineVer;
	//Aԍ̊Ǘ
	int[][] lineNumHor;
	int[][] lineNumVer;
	SLContinueLine[] contLines;
	//G[i}XƓ_j
	ArrayList<SLError> errors;
	//e_ɂ̏otOi̕ɏo肷邩ǂj
	boolean [][][] pointDir;
	//[v1.8]w@gۂɁAՖʂł͕s̃G[ێĂ
	boolean unvisibleErrorFlag;
	//
	SLPanel puzzle;
	//-------------------------------------------------------------
	//
	//-------------------------------------------------------------
	public SLData(SLPanel panel){
		formatAll(10,10);
		//
		unvisibleErrorFlag=false;
		//
		puzzle=panel;
	}
	public void formatAll(int wd,int ht){
		width=wd;
		height=ht;
		cellNum=new int[width][height];
		//lu0v̂܂܂ł͂Ȃ
		for(int w=0;w<width;w++){
			for(int h=0;h<height;h++){
				cellNum[w][h]=CELL_NONE;
			}
		}
		//
		formatLine();
	}
	//𓚏ŒڌĂ΂
	public void formatLine(){
		//lu0vi=LINE_BLANKĵ܂܂ł
		lineHor=new int[width][height+1];
		lineVer=new int[width+1][height];
		//
		formatLineNum();
	}
	public void formatLineNum(){
		//lu0vi=LINE_BLANKĵ܂܂ł
		lineNumHor=new int[width][height+1];
		lineNumVer=new int[width+1][height];
		//ŏ̂͊ǗpAȍ~͏lunullv̂܂܂ł
		contLines=new SLContinueLine[width*height];
		contLines[0]=new SLContinueLine(0);
		//
		errors=new ArrayList<SLError>();
		//lufalsev̂܂܂ł
		pointDir=new boolean[width+1][height+1][POINT_ALL];
	}
	//[v1.7]~
	public void clearCross(){
		for(int w=0;w<width+1;w++){
			for(int h=0;h<height+1;h++){
				if(getLineByPoint(w,h,DIR_DOWN)==LINE_NONE){
					setLineByPoint(w,h,DIR_DOWN,LINE_BLANK);
				}
				if(getLineByPoint(w,h,DIR_RIGHT)==LINE_NONE){
					setLineByPoint(w,h,DIR_RIGHT,LINE_BLANK);
				}
			}
		}
	}
	//-------------------------------------------------------------
	//w@ŎgIuWFNg̕
	//-------------------------------------------------------------
	private SLData(SLData data){
		width=data.width;
		height=data.height;
		formatAll(width,height);
		for(int w=0;w<width;w++){
			cellNum[w]=data.cellNum[w].clone();
			lineHor[w]=data.lineHor[w].clone();
			lineVer[w]=data.lineVer[w].clone();
			lineNumHor[w]=data.lineNumHor[w].clone();
			lineNumVer[w]=data.lineNumVer[w].clone();
		}
		lineVer[width]=data.lineVer[width].clone();
		lineNumVer[width]=data.lineNumVer[width].clone();
		//
		for(int w=0;w<width+1;w++){
			for(int h=0;h<height+1;h++){
				pointDir[w][h]=data.pointDir[w][h].clone();
			}
		}
		//u0vԂ͕Ă͂ȂilineSumĂ܂j
		for(int c=1;c<width*height;c++){
			if(data.contLines[c]!=null){
				contLines[c]=data.contLines[c].clone();
			}
		}
		//
		unvisibleErrorFlag=false;	//[v1.8]_ŏĂ
		//
		puzzle=data.puzzle;
	}
	public SLData clone(){
		return new SLData(this);
	}
	//-------------------------------------------------------------
	//Qb^[iz͈̔͂lAL蓾Ȃ}XE_ł͔zOɂȂj
	//-------------------------------------------------------------
	public int getCell(int x,int y){
		if(x>=0 && x<width && y>=0 && y<height){
			return cellNum[x][y];
		}else{
			return CELL_NONE;
		}
	}
	public int getLineByCell(int x,int y,int d){
		switch(d){
		case DIR_UP:
			return lineHor[x][y];
		case DIR_DOWN:
			return lineHor[x][y+1];
		case DIR_RIGHT:
			return lineVer[x+1][y];
		case DIR_LEFT:
			return lineVer[x][y];
		default:
			return LINE_NONE;
		}
	}
	public int getLineByPoint(int x,int y,int d){
		switch(d){
		case DIR_UP:
			if(y>0){
				return lineVer[x][y-1];
			}else{
				return LINE_NONE;
			}
		case DIR_DOWN:
			if(y<height){
				return lineVer[x][y];
			}else{
				return LINE_NONE;
			}
		case DIR_RIGHT:
			if(x<width){
				return lineHor[x][y];
			}else{
				return LINE_NONE;
			}
		case DIR_LEFT:
			if(x>0){
				return lineHor[x-1][y];
			}else{
				return LINE_NONE;
			}
		default:
			return LINE_NONE;
		}
	}
	//̕`Fi`悩Ă΂j
	public Color getHorLineColor(int w,int h){
		return contLines[lineNumHor[w][h]].paintColor;
	}
	public Color getVerLineColor(int w,int h){
		return contLines[lineNumVer[w][h]].paintColor;
	}
	//-------------------------------------------------------------
	//Zb^[iz͈̔͂lAL蓾Ȃ}XE_ł͔zOɂȂj
	//-------------------------------------------------------------
	public void setCell(Point p,int v){
		if(p.x>=0 && p.x<width && p.y>=0 && p.y<height){
			cellNum[p.x][p.y]=v;
			//̃}X̃G[`FbNȂ
			checkCellError(p.x,p.y);
		}
	}
	//}EXCxgchangeLine()Ă΂
	public void setLineByPoint(int x,int y,int d,int v){
		switch(d){
		case DIR_UP:
			if(y>0){
				int before=lineVer[x][y-1];
				lineVer[x][y-1]=v;
				setNewVerLineNum(x,y-1,before,v);
			}
			break;
		case DIR_DOWN:
			if(y<height){
				int before=lineVer[x][y];
				lineVer[x][y]=v;
				setNewVerLineNum(x,y,before,v);
			}
			break;
		case DIR_RIGHT:
			if(x<width){
				int before=lineHor[x][y];
				lineHor[x][y]=v;
				setNewHorLineNum(x,y,before,v);
			}
			break;
		case DIR_LEFT:
			if(x>0){
				int before=lineHor[x-1][y];
				lineHor[x-1][y]=v;
				setNewHorLineNum(x-1,y,before,v);
			}
			break;
		}
	}
	//-------------------------------------------------------------
	//G[`FbN
	//-------------------------------------------------------------
	//[hɌĂ΂iG[폜͂Ȃj
	private void checkAllCellError(){
		for(int w=0;w<width;w++){
			for(int h=0;h<height;h++){
				if(cellNum[w][h]>CELL_NONE && cellNum[w][h]<CELL_ALL){
					int line=0;
					int cross=0;
					//
					for(int d=0;d<DIR_ALL;d++){
						switch(getLineByCell(w,h,d)){
						case LINE_NONE:
							cross++;
							break;
						case LINE_EXIST:
							line++;
							break;
						}
					}
					//
					if(line>cellNum[w][h]){
						errors.add(new SLError(w,h,SLError.ER_CELL_OVER));
					}else if(cross>CELL_ALL-cellNum[w][h]){					//~Ŕ
						errors.add(new SLError(w,h,SLError.ER_CELL_LESS));
					}
				}
			}
		}
	}
	//̈ʒũG[`FbNiG[폜j
	private void checkCellError(int w,int h){
		//[v1.7]ł̈ʒuɈړi0`3͈̔͊OłG[폜͂˂΂ȂȂj
		deleteCellError(w,h);	//̈ʒũG[폜
		//
		int line=0;
		int cross=0;
		//
		int cell=getCell(w,h);
		if(cell>CELL_NONE && cell<CELL_ALL){
			for(int d=0;d<DIR_ALL;d++){
				switch(getLineByCell(w,h,d)){
				case LINE_NONE:
					cross++;
					break;
				case LINE_EXIST:
					line++;
					break;
				}
			}
			//[v1.7]ifOֈړ
			//deleteCellError(w,h);	//̈ʒû̃G[폜
			//
			if(line>cell){
				errors.add(new SLError(w,h,SLError.ER_CELL_OVER));
			}else if(cross>CELL_ALL-cell){			//~Ŕ
				errors.add(new SLError(w,h,SLError.ER_CELL_LESS));
			}
		}
	}
	private void checkPointError(int w,int h){
		int line=0;
		int blank=0;
		//
		for(int d=0;d<DIR_ALL;d++){
			switch(getLineByPoint(w,h,d)){
			case LINE_BLANK:
				blank++;
				break;
			case LINE_EXIST:
				line++;
				break;
			}
		}
		//̈ʒû̃G[폜
		deletePointError(w,h);
		//
		switch(line){
		case 0:
		case 2:
			break;
		case 1:
			if(blank==0){
				errors.add(new SLError(w,h,SLError.ER_POINT_STOP));
			}
			break;
		case 3:
		case 4:
			errors.add(new SLError(w,h,SLError.ER_POINT_TREE));
			break;
		}
	}
	//G[OɁÄʒuɊɃG[΍폜
	private void deleteCellError(int w,int h){
		for(int e=0;e<errors.size();e++){
			if(errors.get(e).agreeCellErrorPos(w, h)){
				errors.remove(e);
				return;
			}
		}
	}
	private void deletePointError(int w,int h){
		for(int e=0;e<errors.size();e++){
			if(errors.get(e).agreePointErrorPos(w, h)){
				errors.remove(e);
				return;
			}
		}
	}
	//-------------------------------------------------------------
	//[h̑S`FbNiAƃ}XE_G[j
	//-------------------------------------------------------------
	private void setAllLineNum(){
		int lineNum=1;		//AɓĂ͂߂ԍiVAłƎɔđj
		for(int w=0;w<width;w++){
			for(int h=0;h<height;h++){
				lineNum=setHorLineNum(w,h,lineNum);
				lineNum=setVerLineNum(w,h,lineNum);
			}
			lineNum=setHorLineNum(w,height,lineNum);
		}
		for(int h=0;h<height;h++){
			lineNum=setVerLineNum(width,h,lineNum);
		}
		//}XG[
		checkAllCellError();
	}
	//_G[`FbN
	private int setHorLineNum(int w,int h,int lineNum){
		if(lineHor[w][h]==LINE_EXIST && lineNumHor[w][h]==LINE_BLANK){	//VAȂ
			contLines[lineNum]=new SLContinueLine();
			lineNumHor[w][h]=lineNum;
			setOneLineNumByPoint(w,h,DIR_RIGHT,lineNum,true);
			setOneLineNumByPoint(w+1,h,DIR_LEFT,lineNum,true);
			return lineNum+1;
		}else{
			return lineNum;
		}
	}
	private int setVerLineNum(int w,int h,int lineNum){
		if(lineVer[w][h]==LINE_EXIST && lineNumVer[w][h]==LINE_BLANK){	//VAȂ
			contLines[lineNum]=new SLContinueLine();
			lineNumVer[w][h]=lineNum;
			setOneLineNumByPoint(w,h,DIR_DOWN,lineNum,true);
			setOneLineNumByPoint(w,h+1,DIR_UP,lineNum,true);
			return lineNum+1;
		}else{
			return lineNum;
		}
	}
	//ċNĂяołǂĂi[ṽ`FbNjAA̒f[̓o^
	//f[^ύXɂĂ΂i͓̎_G[`FbNȂj
	private void setOneLineNumByPoint(int x,int y,int fromDir,int lineNum,boolean errorCheckFlag){
		try{
			setOneLineNumByPointThrow(x,y,fromDir,lineNum,errorCheckFlag);
		}catch(StackOverflowError e){
			//pY肪傫AȂƁAStackOverflowError
			JOptionPane.showMessageDialog(puzzle,"̌EiStackOverflowErrorj\nꕔ̋@\ɓȂꂠ",
																									"G[",JOptionPane.ERROR_MESSAGE);
		}
	}
	private void setOneLineNumByPointThrow(int x,int y,int fromDir,int lineNum,boolean errorCheckFlag) throws StackOverflowError{
		int exit=0;
		int stop=0;
		//
		if(fromDir!=DIR_UP){
			switch(getLineByPoint(x,y,DIR_UP)){
			case LINE_EXIST:
				if(lineNumVer[x][y-1]!=lineNum){
					lineNumVer[x][y-1]=lineNum;
					setOneLineNumByPointThrow(x,y-1,DIR_DOWN,lineNum,errorCheckFlag);
				}else{
					contLines[lineNum].changeLoop(true,this);
				}
				exit++;
				break;
			case LINE_NONE:
				stop++;
			}
		}
		if(fromDir!=DIR_DOWN){
			switch(getLineByPoint(x,y,DIR_DOWN)){
			case LINE_EXIST:
				if(lineNumVer[x][y]!=lineNum){
					lineNumVer[x][y]=lineNum;
					setOneLineNumByPointThrow(x,y+1,DIR_UP,lineNum,errorCheckFlag);
				}else{
					contLines[lineNum].changeLoop(true,this);
				}
				exit++;
				break;
			case LINE_NONE:
				stop++;
			}			
		}
		if(fromDir!=DIR_RIGHT){
			switch(getLineByPoint(x,y,DIR_RIGHT)){
			case LINE_EXIST:
				if(lineNumHor[x][y]!=lineNum){
					lineNumHor[x][y]=lineNum;
					setOneLineNumByPointThrow(x+1,y,DIR_LEFT,lineNum,errorCheckFlag);
				}else{
					contLines[lineNum].changeLoop(true,this);
				}
				exit++;
				break;
			case LINE_NONE:
				stop++;
			}			
		}
		if(fromDir!=DIR_LEFT){
			switch(getLineByPoint(x,y,DIR_LEFT)){
			case LINE_EXIST:
				if(lineNumHor[x-1][y]!=lineNum){
					lineNumHor[x-1][y]=lineNum;
					setOneLineNumByPointThrow(x-1,y,DIR_RIGHT,lineNum,errorCheckFlag);
				}else{
					contLines[lineNum].changeLoop(true,this);
				}
				exit++;
				break;
			case LINE_NONE:
				stop++;
			}			
		}
		//s~܂ȂA̘Aɒf[o^
		if(exit==0){
			contLines[lineNum].terminalPoints.add(new Point(x,y));
		}
		//
		if(errorCheckFlag){
			if(exit>1){
				errors.add(new SLError(x,y,SLError.ER_POINT_TREE));
			}else if(stop==3){
				errors.add(new SLError(x,y,SLError.ER_POINT_STOP));
			}
		}
	}
	//-------------------------------------------------------------
	//f[^ύX̌̃`FbNi͂ĂяojA߂l͕ύXꂽAԍix4͂ŎgpjAA̒f[ύX
	//-------------------------------------------------------------
	public int setNewHorLineNum(int x,int y,int before,int after){
		//e͈͂̃G[`FbN
		checkCellError(x,y-1);
		checkCellError(x,y);
		checkPointError(x,y);
		checkPointError(x+1,y);
		//x4͂Ŏgpiꂽꍇ̂ݗLj
		int changedLineNum=0;
		//
		if(before!=LINE_EXIST){
			if(after==LINE_EXIST){					//hꂽꍇ̃`FbN
				int left=getContLineNumByPoint(x,y,DIR_RIGHT);
				int right=getContLineNumByPoint(x+1,y,DIR_LEFT);
				//
				if(left>LINE_BLANK){
					if(right==LINE_BLANK){							//
						lineNumHor[x][y]=left;
						//
						if(checkTerminal(x,y,DIR_RIGHT)){	contLines[left].terminalPoints.remove(new Point(x,y));	}
						contLines[left].terminalPoints.add(new Point(x+1,y));
						changedLineNum=left;
					}else{											//ڑ
						//
						if(left<right){						//2{@|@1{
							if(checkTerminal(x,y,DIR_RIGHT)){	contLines[left].terminalPoints.remove(new Point(x,y));	}
							changedLineNum=left;
							//
							lineNumHor[x][y]=left;
							setOneLineNumByPoint(x+1,y,DIR_LEFT,left,false);
							//ԍ傫̘A͍폜
							contLines[right]=null;
							SLContinueLine.lineSum--;
						}else if(left>right){
							if(checkTerminal(x+1,y,DIR_LEFT)){	contLines[right].terminalPoints.remove(new Point(x+1,y));	}
							changedLineNum=right;
							//
							lineNumHor[x][y]=right;
							setOneLineNumByPoint(x,y,DIR_RIGHT,right,false);
							//ԍ傫̘A͍폜
							contLines[left]=null;
							SLContinueLine.lineSum--;
						}else{									//1{@|@[v
							if(checkTerminal(x,y,DIR_RIGHT)){	contLines[left].terminalPoints.remove(new Point(x,y));		}
							if(checkTerminal(x+1,y,DIR_LEFT)){	contLines[right].terminalPoints.remove(new Point(x+1,y));	}
							//changedLineNum=left;	//i[vɂȂΉ͂ȂĂj
							//
							lineNumHor[x][y]=left;
							contLines[left].changeLoop(true,this);
						}
					}
				}else{
					if(right>LINE_BLANK){							//
						lineNumHor[x][y]=right;
						//
						if(checkTerminal(x+1,y,DIR_LEFT)){	contLines[right].terminalPoints.remove(new Point(x+1,y));	}
						contLines[right].terminalPoints.add(new Point(x,y));
						changedLineNum=right;
					}else{											//VK
						lineNumHor[x][y]=getEmptyContLineNum();
						contLines[lineNumHor[x][y]]=new SLContinueLine(new Point(x,y),new Point(x+1,y));
						//changedLineNum=0;	//if[Ԃ͐Ax4͑ΏۊOj
					}
				}
			}
		}else{										//ꂽꍇ̃`FbN
			if(after!=LINE_EXIST){
				int left=getContLineNumByPoint(x,y,DIR_RIGHT);
				int right=getContLineNumByPoint(x+1,y,DIR_LEFT);
				//
				if(left>LINE_BLANK){
					if(right==LINE_BLANK){							//Zk
						lineNumHor[x][y]=LINE_BLANK;
						//
						contLines[left].terminalPoints.remove(new Point(x+1,y));
						if(checkTerminal(x,y,DIR_RIGHT)){	contLines[left].terminalPoints.add(new Point(x,y));	}
					}else{											//f
						//
						if(!contLines[left].loopFlag){			//1{@|@2{
							lineNumHor[x][y]=LINE_BLANK;
							//VA
							int lineNum=getEmptyContLineNum();
							contLines[lineNum]=new SLContinueLine();
							setOneLineNumByPoint(x+1,y,DIR_LEFT,lineNum,false);
							//VAiEjɒf[o^IŁAÂAijd폜
							//E̒f[́Ǎłꂼɓo^
							contLines[left].deleteTerminals(contLines[lineNum].terminalPoints);
							if(checkTerminal(x,y,DIR_RIGHT)){	contLines[left].terminalPoints.add(new Point(x,y));			}
							if(checkTerminal(x+1,y,DIR_LEFT)){	contLines[lineNum].terminalPoints.add(new Point(x+1,y));	}
						}else{									//[v@|@1{Hi[v̂܂܁A܂́A2{肤j
							//d[vmFKv
							lineNumHor[x][y]=LINE_BLANK;
							//񃋁[vĂiԍ͍폜ȂAԍς̂h߁j
							contLines[left].changeLoop(false,this);
							//EʔԍŒuAԍƃ`FbNłȂ̂Łi[vł邩j
							int lineNum=getEmptyContLineNum();
							contLines[lineNum]=new SLContinueLine();
							setOneLineNumByPoint(x+1,y,DIR_LEFT,lineNum,false);
							//E͂ȂĂǂi܂ŔԍύXꂽj
							if(getContLineNumByPoint(x,y,DIR_RIGHT)==lineNum){	//1{ɁiύXmFAȂĂj
								//ԍŃ[vă`FbNi炩ߒf[̓NAAdh߁j
								contLines[left].terminalPoints.clear();
								setOneLineNumByPoint(x+1,y,DIR_LEFT,left,false);
								//ʔԍ[vi΁jƂƂɏ
								contLines[lineNum].changeLoop(false,this);
								contLines[lineNum]=null;
								SLContinueLine.lineSum--;
								//o^͉E̓_݂̂łi͂ǂēo^Ă͂j
								if(checkTerminal(x+1,y,DIR_LEFT)){	contLines[left].terminalPoints.add(new Point(x+1,y));	}
							}else{												//2{ɁiύXꂸAȂĂȂj
								//E̐VA͐
								if(checkTerminal(x+1,y,DIR_LEFT)){	contLines[lineNum].terminalPoints.add(new Point(x+1,y));	}
								//ʔԍ2ŒuAԍƃ`FbNłȂ̂Łi[vł邩j
								int lineNum2=getEmptyContLineNum();
								contLines[lineNum2]=new SLContinueLine();
								setOneLineNumByPoint(x,y,DIR_RIGHT,lineNum2,false);
								//ԍŃ[vă`FbNi炩ߒf[̓NAAdh߁j
								contLines[left].terminalPoints.clear();
								setOneLineNumByPoint(x,y,DIR_RIGHT,left,false);
								//ʔԍ2[vi΁jƂƂɏ
								contLines[lineNum2].changeLoop(false,this);
								contLines[lineNum2]=null;
								SLContinueLine.lineSum--;
								//
								if(checkTerminal(x,y,DIR_RIGHT)){	contLines[left].terminalPoints.add(new Point(x,y));	}
							}
						}
					}
				}else{
					if(right>LINE_BLANK){							//Zk
						lineNumHor[x][y]=LINE_BLANK;
						//
						contLines[right].terminalPoints.remove(new Point(x,y));
						if(checkTerminal(x+1,y,DIR_LEFT)){	contLines[right].terminalPoints.add(new Point(x+1,y));	}
					}else{											//
						contLines[lineNumHor[x][y]]=null;
						SLContinueLine.lineSum--;
						//̌ŃuNɂ
						lineNumHor[x][y]=LINE_BLANK;
					}
				}
			}
		}
		//
		return changedLineNum;
	}
	public int setNewVerLineNum(int x,int y,int before,int after){
		//e͈͂̃G[`FbN
		checkCellError(x-1,y);
		checkCellError(x,y);
		checkPointError(x,y);
		checkPointError(x,y+1);
		//Level4Ŏgpiꂽꍇ̂ݗLj
		int changedLineNum=0;
		//
		if(before!=LINE_EXIST){
			if(after==LINE_EXIST){					//hꂽꍇ̃`FbN
				int up=getContLineNumByPoint(x,y,DIR_DOWN);
				int down=getContLineNumByPoint(x,y+1,DIR_UP);
				//
				if(up>LINE_BLANK){
					if(down==LINE_BLANK){							//
						lineNumVer[x][y]=up;
						//
						if(checkTerminal(x,y,DIR_DOWN)){	contLines[up].terminalPoints.remove(new Point(x,y));	}
						contLines[up].terminalPoints.add(new Point(x,y+1));
						changedLineNum=up;
					}else{											//ڑ
						//
						if(up<down){						//2{@|@1{
							if(checkTerminal(x,y,DIR_DOWN)){	contLines[up].terminalPoints.remove(new Point(x,y));	}
							changedLineNum=up;
							//
							lineNumVer[x][y]=up;
							setOneLineNumByPoint(x,y+1,DIR_UP,up,false);
							//ԍ傫̘A͍폜
							contLines[down]=null;
							SLContinueLine.lineSum--;
						}else if(up>down){
							if(checkTerminal(x,y+1,DIR_UP)){	contLines[down].terminalPoints.remove(new Point(x,y+1));	}
							changedLineNum=down;
							//
							lineNumVer[x][y]=down;
							setOneLineNumByPoint(x,y,DIR_DOWN,down,false);
							//ԍ傫̘A͍폜
							contLines[up]=null;
							SLContinueLine.lineSum--;
						}else{									//1{@|@[v
							if(checkTerminal(x,y,DIR_DOWN)){	contLines[up].terminalPoints.remove(new Point(x,y));		}
							if(checkTerminal(x,y+1,DIR_UP)){	contLines[down].terminalPoints.remove(new Point(x,y+1));	}
							//changedLineNum=up;	//i[vɂȂΉ͂ȂĂj
							//
							lineNumVer[x][y]=up;
							contLines[up].changeLoop(true,this);
						}
					}
				}else{
					if(down>LINE_BLANK){							//
						lineNumVer[x][y]=down;
						//
						if(checkTerminal(x,y+1,DIR_UP)){	contLines[down].terminalPoints.remove(new Point(x,y+1));	}
						contLines[down].terminalPoints.add(new Point(x,y));
						changedLineNum=down;
					}else{											//VK
						lineNumVer[x][y]=getEmptyContLineNum();
						contLines[lineNumVer[x][y]]=new SLContinueLine(new Point(x,y),new Point(x,y+1));
						//changedLineNum=up;	//if[Ԃ͐Ax4͑ΏۊOj
					}
				}
			}
		}else{										//ꂽꍇ̃`FbN
			if(after!=LINE_EXIST){
				int up=getContLineNumByPoint(x,y,DIR_DOWN);
				int down=getContLineNumByPoint(x,y+1,DIR_UP);
				//
				if(up>LINE_BLANK){
					if(down==LINE_BLANK){							//Zk
						lineNumVer[x][y]=LINE_BLANK;
						//
						contLines[up].terminalPoints.remove(new Point(x,y+1));
						if(checkTerminal(x,y,DIR_DOWN)){	contLines[up].terminalPoints.add(new Point(x,y));	}
					}else{											//f
						//
						if(!contLines[up].loopFlag){			//1{@|@2{
							lineNumVer[x][y]=LINE_BLANK;
							//VA
							int lineNum=getEmptyContLineNum();
							contLines[lineNum]=new SLContinueLine();
							setOneLineNumByPoint(x,y+1,DIR_UP,lineNum,false);
							//VAijɒf[o^IŁAÂAijd폜
							//㉺̒f[́Ǎłꂼɓo^
							contLines[up].deleteTerminals(contLines[lineNum].terminalPoints);
							if(checkTerminal(x,y,DIR_DOWN)){	contLines[up].terminalPoints.add(new Point(x,y));	}
							if(checkTerminal(x,y+1,DIR_UP)){	contLines[lineNum].terminalPoints.add(new Point(x,y+1));	}
						}else{									//[v@|@1{Hi[v̂܂܁A܂́A2{肤j
							//d[vmFKv
							lineNumVer[x][y]=LINE_BLANK;
							//񃋁[vĂiԍ͍폜ȂAԍς̂h߁j
							contLines[up].changeLoop(false,this);
							//ʔԍŒuAԍƃ`FbNłȂ̂Łi[vł邩j
							int lineNum=getEmptyContLineNum();
							contLines[lineNum]=new SLContinueLine();
							setOneLineNumByPoint(x,y+1,DIR_UP,lineNum,false);
							//㉺͂ȂĂǂi܂ŔԍύXꂽj
							if(getContLineNumByPoint(x,y,DIR_DOWN)==lineNum){	//1{ɁiύXmFAȂĂj
								//ԍŃ[vă`FbNi炩ߒf[̓NAAdh߁j
								contLines[up].terminalPoints.clear();
								setOneLineNumByPoint(x,y+1,DIR_UP,up,false);
								//ʃio[[vi΁jƂƂɏ
								contLines[lineNum].changeLoop(false,this);
								contLines[lineNum]=null;
								SLContinueLine.lineSum--;
								//o^͉̓_݂̂łi͂ǂēo^Ă͂j
								if(checkTerminal(x,y+1,DIR_UP)){	contLines[up].terminalPoints.add(new Point(x,y+1));	}
							}else{												//2{ɁiύXꂸAȂĂȂj
								//̐VA͐
								if(checkTerminal(x,y+1,DIR_UP)){	contLines[lineNum].terminalPoints.add(new Point(x,y+1));	}
								//ォʔԍ2ŒuAԍƃ`FbNłȂ̂Łi[vł邩j
								int lineNum2=getEmptyContLineNum();
								contLines[lineNum2]=new SLContinueLine();
								setOneLineNumByPoint(x,y,DIR_DOWN,lineNum2,false);
								//ԍŃ[vă`FbNi炩ߒf[̓NAAdh߁j
								contLines[up].terminalPoints.clear();
								setOneLineNumByPoint(x,y,DIR_DOWN,up,false);
								//ʔԍ2[vi΁jƂƂɏ
								contLines[lineNum2].changeLoop(false,this);
								contLines[lineNum2]=null;
								SLContinueLine.lineSum--;
								//
								if(checkTerminal(x,y,DIR_DOWN)){	contLines[up].terminalPoints.add(new Point(x,y));	}
							}
						}
					}
				}else{
					if(down>LINE_BLANK){							//Zk
						lineNumVer[x][y]=LINE_BLANK;
						//
						contLines[down].terminalPoints.remove(new Point(x,y));
						if(checkTerminal(x,y+1,DIR_UP)){	contLines[down].terminalPoints.add(new Point(x,y+1));	}
					}else{											//
						contLines[lineNumVer[x][y]]=null;
						SLContinueLine.lineSum--;
						//̌ŃuNɂ
						lineNumVer[x][y]=LINE_BLANK;
					}
				}
			}
		}
		//
		return changedLineNum;
	}
	//z͈̔͂l
	private int getContLineNumByPoint(int x,int y,int fromDir){
		if(fromDir!=DIR_UP){
			if(y>0){
				if(lineNumVer[x][y-1]>LINE_BLANK){
					return lineNumVer[x][y-1];
				}
			}
		}
		if(fromDir!=DIR_DOWN){
			if(y<height){
				if(lineNumVer[x][y]>LINE_BLANK){
					return lineNumVer[x][y];
				}
			}
		}
		if(fromDir!=DIR_RIGHT){
			if(x<width){
				if(lineNumHor[x][y]>LINE_BLANK){
					return lineNumHor[x][y];
				}
			}
		}
		if(fromDir!=DIR_LEFT){
			if(x>0){
				if(lineNumHor[x-1][y]>LINE_BLANK){
					return lineNumHor[x-1][y];
				}
			}
		}
		//
		return LINE_BLANK;
	}
	//̓_f[łA܂́Af[ɂȂ̂iύX̒f[j
	private boolean checkTerminal(int x,int y,int fromDir){
		int exist=0;
		for(int d=0;d<DIR_ALL;d++){
			if(d==fromDir){	continue;	}
			if(getLineByPoint(x,y,d)==LINE_EXIST){
				exist++;
			}
		}
		//
		if(exist==1){
			return true;
		}else{
			return false;
		}
	}
	//󂢂Ăŏ̘Asԍ𓾂
	private int getEmptyContLineNum(){
		for(int c=0;c<width*height;c++){
			if(contLines[c]==null){
				return c;
			}
		}
		//
		return 0;
	}
	//-------------------------------------------------------------
	//[h
	//-------------------------------------------------------------
	public boolean setLoadString(String[] ld){
		//ꎞIɊi[imF̂߁j
		int tmpWidth,tmpHeight;
		int[][] tmpNumber;
		int[][] tmpLineHor;
		int[][] tmpLineVer;
		//ƍ
		if(ld!=null && ld.length>=2){
			try{
				tmpHeight=Integer.parseInt(ld[0]);
				tmpWidth=Integer.parseInt(ld[1]);
			}catch(NumberFormatException e){
				return false;
			}
		}else{
			return false;
		}
		//*** version 1.0 ł͏c̏ԂԈႦ̂ŁȂΉ ***
		if(ld.length>=3){
			StringTokenizer st=new StringTokenizer(ld[2]," ");
			if(st.countTokens()!=tmpWidth){
				int tmp=tmpWidth;tmpWidth=tmpHeight;tmpHeight=tmp;
			}
		}
		//z
		tmpNumber=new int[tmpWidth][tmpHeight];
		tmpLineHor=new int[tmpWidth][tmpHeight+1];
		tmpLineVer=new int[tmpWidth+1][tmpHeight];
		for(int w=0;w<tmpWidth;w++){
			for(int h=0;h<tmpHeight;h++){
				tmpNumber[w][h]=CELL_NONE;
				//tmpLineHor[w][h]=LINE_BLANK;
				//tmpLineVer[w][h]=LINE_BLANK;
			}
			//tmpLineHor[w][tmpHeight]=LINE_BLANK;
		}
		/*
		for(int h=0;h<tmpHeight;h++){
			tmpLineVer[tmpWidth][h]=LINE_BLANK;
		}
		*/
		//}X̃f[^Ȃ
		if(ld.length<2+tmpHeight){	return false;	}
		//
		StringTokenizer st;
		ArrayList<String> array;
		//}Xij
		for(int h=0;h<tmpHeight;h++){
			st=new StringTokenizer(ld[2+h]," ");
			array=new ArrayList<String>();
			while(st.hasMoreTokens()){	//
				array.add(st.nextToken());
			}
			//
			if(array.size()==tmpWidth){
				for(int w=0;w<tmpWidth;w++){
					if(array.get(w).equals(".")){
						tmpNumber[w][h]=CELL_NONE;
					}else{
						try{
							tmpNumber[w][h]=Integer.parseInt(array.get(w));
						}catch(NumberFormatException e){
							return false;
						}
					}
				}
			}else{
				return false;
			}
		}
		//iZ[uf[^ɖj
		if(ld.length>=3+tmpHeight*3){
			//
			for(int h=0;h<tmpHeight+1;h++){
				st=new StringTokenizer(ld[2+tmpHeight+h]," ");
				array=new ArrayList<String>();
				while(st.hasMoreTokens()){	//
					array.add(st.nextToken());
				}
				//
				if(array.size()==tmpWidth){
					for(int w=0;w<tmpWidth;w++){
						try{
							tmpLineHor[w][h]=Integer.parseInt(array.get(w));
						}catch(NumberFormatException e){
							return false;
						}
					}
				}else{
					return false;
				}
			}
			//c
			for(int h=0;h<tmpHeight;h++){
				st=new StringTokenizer(ld[3+tmpHeight*2+h]," ");
				array=new ArrayList<String>();
				while(st.hasMoreTokens()){	//
					array.add(st.nextToken());
				}
				//
				if(array.size()==tmpWidth+1){
					for(int w=0;w<tmpWidth+1;w++){
						try{
							tmpLineVer[w][h]=Integer.parseInt(array.get(w));
						}catch(NumberFormatException e){
							return false;
						}
					}
				}else{
					return false;
				}
			}
		}
		//f[^Ă͂
		width=tmpWidth;
		height=tmpHeight;
		cellNum=tmpNumber;
		lineHor=tmpLineHor;
		lineVer=tmpLineVer;
		//AԍƃG[`FbN
		formatLineNum();
		setAllLineNum();
		//
		return true;
	}
	public boolean setCSVString(String[] ld){
		//ꎞIɊi[imF̂߁j
		int tmpWidth,tmpHeight;
		int[][] tmpNumber;
		int[][] tmpLineHor;
		int[][] tmpLineVer;
		//ƍ
		if(ld!=null && ld.length>0){
			//߂
			int a1=-1;
			tmpWidth=-1;
			do{		//J}̌ij߂郋[v
				tmpWidth++;
				a1=ld[0].indexOf(",",a1+1);
			}while(a1!=-1);		//J}ȂȂ΃[v𔲂
			if(tmpWidth<=0){	return false;	}
			//߂
			tmpHeight=ld.length;
		}else{
			return false;
		}
		//z
		tmpNumber=new int[tmpWidth][tmpHeight];
		tmpLineHor=new int[tmpWidth][tmpHeight+1];
		tmpLineVer=new int[tmpWidth+1][tmpHeight];
		for(int w=0;w<tmpWidth;w++){
			for(int h=0;h<tmpHeight;h++){
				tmpNumber[w][h]=CELL_NONE;
			}
		}
		//}Xij
		for(int h=0;h<tmpHeight;h++){
			//sƂɕ\邩m߂
			int a1=-1;
			int tmpW=-1;
			do{		//J}̌ij߂郋[v
				tmpW++;
				a1=ld[h].indexOf(",",a1+1);
			}while(a1!=-1);		//J}ȂȂ΃[v𔲂
			if(tmpW<tmpWidth){	return false;	}
			//
			int b1=-1;
			int b2=-1;
			for(int w=0;w<tmpWidth;w++){	//\̂͊mFς
				b1=b2;
				b2=ld[h].indexOf(",",b1+1);
				//
				if(b2>b1+1){				//ew肳Ăꍇ̂
					try{
						tmpNumber[w][h]=Integer.parseInt(ld[h].substring(b1+1,b2));
						switch(tmpNumber[w][h]){
						case SLData.CELL_NONE:	//-1
						case 0:
						case 1:
						case 2:
						case 3:
						case SLData.CELL_ANY:	//5
							break;
						case SLData.CELL_ALL:	//4
						default:
							return false;
						}
					}catch(NumberFormatException e){
						return false;
					}
				}
			}
		}
		//f[^Ă͂
		width=tmpWidth;
		height=tmpHeight;
		cellNum=tmpNumber;
		lineHor=tmpLineHor;
		lineVer=tmpLineVer;
		//͈ĂȂ̂ŏ̂݁iAԍƃG[`FbN͕svj
		formatLineNum();
		//
		return true;
	}
	//-------------------------------------------------------------
	//Z[u
	//-------------------------------------------------------------
	public String getSaveString(){
		String br=System.getProperty("line.separator");
		StringBuffer ret=new StringBuffer();
		//Z[uf[^쐬
		//cE
		ret.append(height).append(br);
		ret.append(width).append(br);
		//}X
		for(int h=0;h<height;h++){
			for(int w=0;w<width;w++){
				if(cellNum[w][h]==CELL_NONE){
					ret.append(". ");
				}else{
					ret.append(cellNum[w][h]).append(" ");
				}
			}
			ret.append(br);
		}
		//
		for(int h=0;h<height+1;h++){
			for(int w=0;w<width;w++){
				if(lineHor[w][h]>=LINE_EXIST){
					ret.append("1 ");
				}else{
					ret.append(lineHor[w][h]).append(" ");
				}
			}
			ret.append(br);
		}
		//c
		for(int h=0;h<height;h++){
			for(int w=0;w<width+1;w++){
				if(lineVer[w][h]>=LINE_EXIST){
					ret.append("1 ");
				}else{
					ret.append(lineVer[w][h]).append(" ");
				}
			}
			ret.append(br);
		}
		//
		return ret.toString();
	}
	public String getCSVString(){
		String br=System.getProperty("line.separator");
		StringBuffer ret=new StringBuffer();
		//CSVf[^쐬
		//}X̂
		for(int h=0;h<height;h++){
			for(int w=0;w<width;w++){
				if(cellNum[w][h]!=CELL_NONE){
					ret.append(cellNum[w][h]);
				}
				ret.append(",");
			}
			ret.append("]").append(br);
		}
		//
		return ret.toString();
	}
	//-------------------------------------------------------------
	//A̕`FύX
	//-------------------------------------------------------------
	public void changeAllLineColor(){
		for(int c=0;c<width*height;c++){
			if(contLines[c]!=null){
				contLines[c].paintColor=SLContinueLine.makeColor();
			}
		}
	}
	/*
	//-------------------------------------------------------------
	//[v1.4]Pƃ[vɃ[ȊÓu͂ꐔv邩iPƃ[vĂԂŃ`FbN̂ߌĂ΂ji[v1.7]Œuj
	//-------------------------------------------------------------
	public boolean checkNolineNumber(){
		for(int w=0;w<width;w++){
			for(int h=0;h<height;h++){
				if(cellNum[w][h]>0 && cellNum[w][h]<CELL_ALL){
					if(getLineByCell(w,h,DIR_UP)!=LINE_EXIST && getLineByCell(w,h,DIR_DOWN)!=LINE_EXIST && 
						getLineByCell(w,h,DIR_RIGHT)!=LINE_EXIST && getLineByCell(w,h,DIR_LEFT)!=LINE_EXIST){
							return true;
					}
				}
			}
		}
		//
		return false;
	}*/
	//-------------------------------------------------------------
	//[v1.7]Pƃ[vɁus̐v邩iPƃ[vĂԂŃ`FbN̂ߌĂ΂j
	//-------------------------------------------------------------
	public boolean checkLinelessNumber(){
		for(int w=0;w<width;w++){
			for(int h=0;h<height;h++){
				if(cellNum[w][h]>0 && cellNum[w][h]<CELL_ALL){
					//
					int line=0;
					for(int d=0;d<DIR_ALL;d++){
						if(getLineByCell(w,h,d)==LINE_EXIST){
							line++;
						}
					}
					//
					if(line<cellNum[w][h]){
						return true;
					}
				}
			}
		}
		//
		return false;
	}	
}
