
import java.awt.Color;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.image.BufferedImage;
import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.ArrayList;

import javax.imageio.ImageIO;
import javax.print.Doc;
import javax.print.DocFlavor;
import javax.print.DocPrintJob;
import javax.print.PrintException;
import javax.print.PrintService;
import javax.print.PrintServiceLookup;
import javax.print.ServiceUI;
import javax.print.SimpleDoc;
import javax.print.attribute.DocAttributeSet;
import javax.print.attribute.HashDocAttributeSet;
import javax.print.attribute.HashPrintRequestAttributeSet;
import javax.print.attribute.PrintRequestAttributeSet;
import javax.print.event.PrintJobEvent;
import javax.print.event.PrintJobListener;
import javax.swing.JFileChooser;
//import javax.swing.filechooser.FileNameExtensionFilter;
import javax.swing.JOptionPane;

public class SLFileIO implements PrintJobListener {
	//----------萔------------
	//t@C
	private static final String LANGUAGE_FILE="language.txt";
	//t@C擾ۂɃ^Cvw肷萔
	private static final int OUT_TXT=0;
	private static final int OUT_CSV=1;
	private static final int OUT_PNG=2;
	private static final int OUT_LNG=3;
	//----------ϐ------------
	//Ăяo
	SLFrame frame;
	//
	JFileChooser chooser;
	//
	File saveFile,csvFile,graphicFile,languageFile,preFile;
	//
	//-------------------------------------------------------------
	//
	//-------------------------------------------------------------
	public SLFileIO(SLFrame fr){
		//
		frame=fr;
		//vOfBNglɂč쐬
		chooser=new JFileChooser(".");
		//chooser=new JFileChooser();
		//
		saveFile=csvFile=graphicFile=languageFile=preFile=null;
	}
	//VK쐬ł̏
	public void formatFileName(){
		saveFile=null;
		//t[̃^CgύX
		frame.setTitleString();
	}
	//-------------------------------------------------------------
	//^Cg
	//-------------------------------------------------------------
	public String getFileName(){
		if(saveFile!=null){
			return saveFile.getName();
		}else{
			return LST.V[LST.UNTITLED];
		}
	}
	//-------------------------------------------------------------
	//[h
	//-------------------------------------------------------------
	public void load(SLPanel puzzleField){
		//[ht@C̃pX𓾂
		if(!getTargetFile(LST.V[LST.LOAD]+" "+LST.V[LST.FILE]+"(*.txt)",LST.V[LST.LOAD],OUT_TXT,false)){	//[hȂȂI
			return;
		}
		//t@Cǂݍ
		String[] fileString=readTextFile(preFile);
		if(fileString==null){
			frame.showErrorDialog(LST.V[LST.FAILURE]+"("+LST.V[LST.FILE]+" "+LST.V[LST.INPUT]+")");
			return;
		}
		//[hf[^𓖂Ă͂߂
		if(!puzzleField.setLoadString(fileString)){
			frame.showErrorDialog(LST.V[LST.FAILURE]+"("+LST.V[LST.DATA]+" "+LST.V[LST.INPUT]+")");
			return;
		}
		//Z[ut@Ci[
		saveFile=preFile;
		//t[̃^CgύX
		frame.setTitleString();
	}
	//-------------------------------------------------------------
	//Z[u
	//-------------------------------------------------------------
	//㏑ۑ
	public void save(SLPanel puzzleField){
		if(saveFile!=null){
			savePuzzleData(saveFile,puzzleField);
		}else{	//Z[ut@C񂪂ȂΖOtĕۑ
			saveAs(puzzleField);
		}
	}
	//Otĕۑ
	public void saveAs(SLPanel puzzleField){
		//Z[ut@C̃pX𓾂
		if(getTargetFile(LST.V[LST.SAVEAS]+" "+LST.V[LST.FILE]+"(*.txt)",LST.V[LST.SAVEAS],OUT_TXT,true)){
			//gqtĂȂΕt
			preFile=addExtension(preFile,"txt");
			//
			savePuzzleData(preFile,puzzleField);
		}
	}
	//Z[ut@C󂯎ăZ[us
	private void savePuzzleData(File file,SLPanel puzzleField){
		//Z[us
		if(!makeTextFile(file,puzzleField.getSaveString(true))){
			frame.showErrorDialog(LST.V[LST.FAILURE]+"("+LST.V[LST.FILE]+" "+LST.V[LST.OUTPUT]+")");
			return;
		}
		//Z[ut@Ci[
		saveFile=preFile;
		//t[̃^CgύX
		frame.setTitleString();
	}
	//-------------------------------------------------------------
	//CSVo
	//-------------------------------------------------------------
	public void inputCSV(SLPanel puzzleField){
		//[ht@C̃pX𓾂
		if(!getTargetFile("CSV "+LST.V[LST.FILE]+"(*.csv)",LST.V[LST.INPUT],OUT_CSV,false)){	//[hȂȂI
			return;
		}
		//t@Cǂݍ
		String[] fileString=readTextFile(preFile);
		if(fileString==null){
			frame.showErrorDialog(LST.V[LST.FAILURE]+"("+LST.V[LST.FILE]+" "+LST.V[LST.INPUT]+")");
			return;
		}
		//[hf[^𓖂Ă͂߂
		if(!puzzleField.setCSVString(fileString)){
			frame.showErrorDialog(LST.V[LST.FAILURE]+"("+LST.V[LST.DATA]+" "+LST.V[LST.INPUT]+")");
			return;
		}
		//Z[ut@C͂ȂȂ
		saveFile=null;
		csvFile=preFile;
		//t[̃^CgύX
		frame.setTitleString();
	}
	public void outputCSV(SLPanel puzzleField){
		//Z[ut@C̃pX𓾂
		if(getTargetFile("CSV "+LST.V[LST.FILE]+"(*.csv)",LST.V[LST.OUTPUT],OUT_CSV,true)){
			//gqtĂȂΕt
			preFile=addExtension(preFile,"csv");
			//Z[us
			if(!makeTextFile(preFile,puzzleField.getCSVString())){
				frame.showErrorDialog(LST.V[LST.FAILURE]+"("+LST.V[LST.FILE]+" "+LST.V[LST.OUTPUT]+")");
				return;
			}
			//Z[ut@CEt[̃^Cg͕s
			csvFile=preFile;
		}
	}
	//-------------------------------------------------------------
	//摜ۑ
	//-------------------------------------------------------------
	public void outputGraphic(SLPanel field){
		//摜
		Dimension dim=field.getPreferredSize();
		BufferedImage image=new BufferedImage(dim.width,dim.height,BufferedImage.TYPE_INT_RGB);
		Graphics g=image.getGraphics();
		g.setColor(Color.WHITE);	//wi𔒂ɂ˂΂ȂȂij
		g.fillRect(0,0,image.getWidth(),image.getHeight());
		//摜ɏ
		field.paintGraphic(image.getGraphics());
		//o͐̉摜t@C̃pX𓾂
		if(getTargetFile("PNG "+LST.V[LST.IMAGE]+"(*.png)",LST.V[LST.OUTPUT],OUT_PNG,true)){
			//gqtĂȂΕt
			preFile=addExtension(preFile,"png");
			//摜ۑs
			try{
				ImageIO.write(image, "png", preFile);
			}catch(IOException ioe){
				frame.showErrorDialog(LST.V[LST.FAILURE]+"("+LST.V[LST.IMAGE]+" "+LST.V[LST.OUTPUT]+")");
				return;
			}
			//t@CXV
			graphicFile=preFile;
		}
	}
	//-------------------------------------------------------------
	//
	//-------------------------------------------------------------
	public void printField(SLPanel field){
		//IuWFNgMIME (Multipurpose Internet Mail Extensions) ^Cv̓
		DocFlavor flavor=DocFlavor.SERVICE_FORMATTED.PRINTABLE;
		//f[^Wuɗ^邽߂̃C^[tF[X
		DocAttributeSet das=new HashDocAttributeSet();
		Doc doc=new SimpleDoc(field,flavor,das);
		//ǂ̂悤Ɉ邩
		PrintRequestAttributeSet pras=new HashPrintRequestAttributeSet();
		//ftHg̈T[rXiv^[EIuWFNgj擾
		PrintService defaultService=PrintServiceLookup.lookupDefaultPrintService();
		//****************************_CAO\********************************************
		//̕^Cv (GIFȂ) ̑Zbg (ʂȂ) ł̈T|[gv^[̃Zbg
		PrintService[] printServices=PrintServiceLookup.lookupPrintServices(flavor,pras);
		//v^[I_CAO\
		PrintService service=ServiceUI.printDialog(null,200,200,printServices,defaultService,flavor,pras);
		//Wu쐬
		DocPrintJob job;
		if(service!=null){
			job=service.createPrintJob();
		}else{
			return;
		}
		//*************************************************************************************
		//֘ÃCxg󂯎悤ɂ
		job.addPrintJobListener(this);
		//
		try{
			job.print(doc,pras);
		}catch(PrintException e){
			frame.showErrorDialog(LST.V[LST.FAILURE]+"("+LST.V[LST.PRINT]+")");
			return;
		}
	}
	//-------------------------------------------------------------
	//t@C̃pX擾i擾trueԂj
	//-------------------------------------------------------------
	private boolean getTargetFile(String title,String button,int outType,boolean overwrite){
		//chooser.resetChoosableFileFilters();
		switch(outType){
		case OUT_TXT:
			//chooser.addChoosableFileFilter(new FileNameExtensionFilter("eLXgt@C(*.txt)","txt"));
			chooser.setSelectedFile(saveFile);
			break;
		case OUT_CSV:
			//chooser.addChoosableFileFilter(new FileNameExtensionFilter("J}؂(*.csv)","csv"));
			chooser.setSelectedFile(csvFile);
			break;
		case OUT_PNG:
			//chooser.addChoosableFileFilter(new FileNameExtensionFilter("PNG摜(*.png)","png"));
			chooser.setSelectedFile(graphicFile);
			break;
		case OUT_LNG:
			chooser.setSelectedFile(languageFile);
			break;
		default:
			//chooser.addChoosableFileFilter(new FileNameExtensionFilter("eLXgt@C(*.txt)","txt"));
			chooser.setSelectedFile(saveFile);
			break;
		}
		//
		chooser.setDialogTitle(title);
		//ꎞt@CɎ擾
		File tmpFile;
		while (true) {
			if (chooser.showDialog(frame,button) != JFileChooser.APPROVE_OPTION) {
				return false;
			}
			tmpFile = chooser.getSelectedFile();
			//㏑mFKvȂ炷
			if(!overwrite){	break;	}
			if (tmpFile.exists()) {
				switch (JOptionPane.showConfirmDialog(frame,tmpFile.getName()+" "+LST.V[LST.OVERLAP]+"\n"+LST.V[LST.SAVE]+" H",LST.V[LST.OVERLAP],JOptionPane.YES_NO_CANCEL_OPTION)){
					case JOptionPane.YES_OPTION:
						break;
					case JOptionPane.NO_OPTION:
						continue;
					case JOptionPane.CANCEL_OPTION:
						return false;
				}
				break;
			} else {
				break;
			}
		}
		//Ă͂
		preFile=tmpFile;
		return true;
	}
	//-------------------------------------------------------------
	//t@CɎw肳ꂽgqtĂȂΕtiÓISLAppletDialogĂ΂j
	//-------------------------------------------------------------
	public static File addExtension(File file,String... extension){
		//gqmF
		int period=file.getPath().lastIndexOf(".");
		if(period!=-1){
			for(int e=0;e<extension.length;e++){
				if(file.getPath().substring(period).equals("."+extension[e])){
					return file;	//̊gqtĂ
				}
			}
			//w肳ꂽgqǂtĂȂ
			return new File(file.getPath()+"."+extension[0]);
		}else{	//ŏ牽̊gqtĂȂ
			return new File(file.getPath()+"."+extension[0]);
		}
	}
	//******************************************************************
	//eLXgt@Co
	//------------------------------------------------------------------
	//w肳ꂽeLXgt@CǂݍœeԂ
	private static String[] readTextFile(File file){
		try{
			ArrayList<String> stringArray=new ArrayList<String>();
			String line;
			//
			BufferedReader br=new BufferedReader(new FileReader(file));
			while((line=br.readLine())!=null){
				stringArray.add(line);
			}
			br.close();
			//
			String[] ret=new String[stringArray.size()];
			for(int i=0;i<stringArray.size();i++){
				ret[i]=stringArray.get(i);
			}
			return ret;
		}catch(Exception e){
			return null;
		}
	}
	//eLXgf[^t@CɕۑiÓISLAppletDialogĂ΂j
	public static boolean makeTextFile(File file,String data){
		try{
			PrintWriter pw=new PrintWriter(new BufferedWriter(new FileWriter(file)));
			pw.print(data);
			pw.close();
			return true;
		}catch(Exception e){
			return false;
		}
	}
	//******************************************************************
	//t@CύX
	//------------------------------------------------------------------
	public void setLanguageFile(boolean startFlag){
		if(startFlag){	//N
			preFile=new File(LANGUAGE_FILE);
		}else{			//rύX
			if(!getTargetFile("language file(*.txt)","OK",OUT_LNG,false)){
				return;		//ȂȂI
			}
		}
		//
		if(preFile.exists()){
			String[] lines=readTextFile(preFile);
			if(lines!=null){
				LST.setStringTable(lines);
			}
			//
			languageFile=preFile;
		}else{	//t@CȂΓ{
			LST.SelectStringTable(LST.D_JAPANESE);
		}
	}
	//-------------------------------------------------------------
	//CxgiɉȂj
	//-------------------------------------------------------------
	public void printDataTransferCompleted(PrintJobEvent arg0) {
	}
	public void printJobCanceled(PrintJobEvent arg0) {
	}
	public void printJobCompleted(PrintJobEvent arg0) {
	}
	public void printJobFailed(PrintJobEvent arg0) {
	}
	public void printJobNoMoreEvents(PrintJobEvent arg0) {
	}
	public void printJobRequiresAttention(PrintJobEvent arg0) {
	}
}
