import java.awt.Color;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.Graphics;
import java.awt.Point;
import java.awt.event.ComponentEvent;
import java.awt.event.ComponentListener;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.awt.event.MouseMotionListener;
import java.awt.print.PageFormat;
import java.awt.print.Printable;
import java.awt.print.PrinterException;

import javax.swing.JColorChooser;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JScrollPane;

public class SLPanel extends JPanel implements MouseListener,
		MouseMotionListener, KeyListener, ComponentListener,Printable {
	//
	static final int MODE_ANSWER=0;
	static final int MODE_EDIT=1;
	//t[TCŶ
	JScrollPane scrollEdge;
	Dimension edgeMargin;
	//
	Color backColor;
	Color numberColor;
	Color gridColor;
	Color lineColor;
	Color crossColor;
	Color errorColor;
	//pY{
	SLData puzzleData;
	//͗p
	SLAnalyzeDialog analyzeDialog;
	//
	int puzzleMode;
	Point selectedCell;			//ҏW[hł̑I}X
	Point draggedPointArea;		//}EXɂ錻݃hbO̓_̈
	boolean aroundFlag;
	boolean errorViewFlag;
	boolean paintLineFlag;
	boolean gridFlag;
	int cellSize;
	int paintRadius;	//̑A_̔a
	int baseX,baseY;
	//pY{̂̃f[^ύX肩ǂ
	boolean changeFlag;
	SLFrame frame;	//^CgύXpAiG[bZ[W\Hj
	//-------------------------------------------------------------
	//
	//-------------------------------------------------------------
	public SLPanel(SLFrame frm){
		//F
		formatColor();
		//
		puzzleData=new SLData(this);
		analyzeDialog=new SLAnalyzeDialog(this);
		//l
		puzzleMode=MODE_ANSWER;
		selectedCell=new Point(0,0);
		draggedPointArea=null;
		aroundFlag=false;
		errorViewFlag=false;
		paintLineFlag=false;
		gridFlag=true;
		cellSize=26;
		paintRadius=calcPaintRadius(cellSize);
		//œKTCYE`挴_̒
		setPreferredPanelSize();
		//
		changeFlag=false;	//łsetChangedȂ
		frame=frm;
		//Cxg̐ݒ
		addMouseListener(this);
		addMouseMotionListener(this);
		addKeyListener(this);
		addComponentListener(this);
		//ÑeLXgݒ͌t@Cǂݍ񂾌ɊOs
		//setLanguageText();
	}
	//wTCYŐVpY쐬
	public void formatPuzzle(int w,int h){
		puzzleData.formatAll(w, h);
		selectedCell.move(0,0);
		//œKTCYE`挴_̒
		setPreferredPanelSize();
		//
		//f[^ύX͂܂Ȃ
		setChanged(false);
		//
		requestFocus();	//ȂĂ悤
	}
	//𓚏
	public void formatAnswer(){
		puzzleData.formatLine();
		//
		setChanged(true);
		//
		repaint();
	}
	//[v1.7]~
	public void clearCross(){
		puzzleData.clearCross();
		//
		setChanged(true);
		//
		repaint();
	}
	//F
	public void formatColor(){
		//
		backColor=Color.WHITE;
		numberColor=Color.BLACK;
		gridColor=Color.BLACK;
		lineColor=Color.BLUE;
		crossColor=Color.MAGENTA;
		errorColor=Color.RED;
		//
		repaint();
	}
	//t[TCŶ߃XN[̈Ƃ̃TCY߂˂΂Ȃ
	public void setScrollEdge(JScrollPane scroll){
		scrollEdge=scroll;
		//
		edgeMargin=new Dimension(scrollEdge.getWidth()-getWidth(),scrollEdge.getHeight()-getHeight());
		if(edgeMargin.width==0 || edgeMargin.height==0){
			edgeMargin=new Dimension(3,3);		//炩̗RœȂWindowsł̒lɐݒ
		}
	}
	//-------------------------------------------------------------
	//t@CύX𔽉f
	//-------------------------------------------------------------
	public void setLanguageText(){
		analyzeDialog.setLanguageText();
	}
	//-------------------------------------------------------------
	//e̐ݒύX
	//-------------------------------------------------------------
	public void changePuzzleMode(int i){
		puzzleMode=i;
		//L[{[ĥ߃tH[JX𓾂
		requestFocus();
		//
		repaint();
	}
	public void changeAroundFlag(boolean f){
		aroundFlag=f;
		//
		setPreferredPanelSize();
	}
	public void changeErrorViewFlag(boolean f){
		errorViewFlag=f;
		//
		repaint();
	}
	public void changePaintLineFlag(boolean f){
		paintLineFlag=f;
		//
		repaint();
	}
	public void changeGridFlag(boolean f){
		gridFlag=f;
		//
		repaint();
	}
	public void changeLineColor(){
		puzzleData.changeAllLineColor();
		//
		repaint();
	}
	public void changeColorBack(){
		Color c=JColorChooser.showDialog(this,LST.V[LST.BACKGROUND],backColor);
		if(c!=null){
			backColor=c;
			//
			repaint();
		}
	}
	public void changeColorNumber(){
		Color c=JColorChooser.showDialog(this,LST.V[LST.NUMBER],numberColor);
		if(c!=null){
			numberColor=c;
			//
			repaint();
		}
	}
	public void changeColorGrid(){
		Color c=JColorChooser.showDialog(this,LST.V[LST.GRID],gridColor);
		if(c!=null){
			gridColor=c;
			//
			repaint();
		}
	}
	public void changeColorLine(){
		Color c=JColorChooser.showDialog(this,LST.V[LST.LINE],lineColor);
		if(c!=null){
			lineColor=c;
			//
			repaint();
		}
	}
	public void changeColorCross(){
		Color c=JColorChooser.showDialog(this,"X",crossColor);
		if(c!=null){
			crossColor=c;
			//
			repaint();
		}
	}
	public boolean checkChanged(){
		return changeFlag;
	}
	public void setChanged(boolean f){
		changeFlag=f;
		//^CgŕύX̗LiZ[uA[hAVK̎ɂ͏dȂ邪j
		frame.setTitleString();
	}
	public int getPuzzleWidth(){
		return puzzleData.width;
	}
	public int getPuzzleHeight(){
		return puzzleData.height;
	}
	public void changeIgnoreFlag(boolean ignore){
		analyzeDialog.setIgnoreFlag(ignore);
	}
	//-------------------------------------------------------------
	//
	//-------------------------------------------------------------
	public void analyzePuzzle(int level){
		analyzeDialog.analyzePuzzle(puzzleData, level);
		//f[^ύXƂiۂ͂ȂȂj
		setChanged(true);
		//
		repaint();
	}
	//-------------------------------------------------------------
	//蔻A𔻒
	//-------------------------------------------------------------
	public void checkQuestion(){	//蔻
		analyzeDialog.checkQuestion(puzzleData);
	}
	public void checkAnswerSimple(){	//𓚔iG[`FbN̂݁j
		String message=makeErrorString();
		if(message.length()==0){
			JOptionPane.showMessageDialog(this,LST.V[LST.CORRECT],LST.V[LST.ANSWER]+" "+LST.V[LST.CHECK],JOptionPane.INFORMATION_MESSAGE);
		}else{
			JOptionPane.showMessageDialog(this,	message.toString(),LST.V[LST.ANSWER]+" "+LST.V[LST.CHECK],JOptionPane.ERROR_MESSAGE);
		}
	}
	public void checkAnswerStract(){	//𓚖蔻i`FbNj
		String message=makeErrorString();
		if(message.length()==0){
			analyzeDialog.checkAnswerStract(puzzleData);	//G[ȂΕ`FbN
		}else{
			JOptionPane.showMessageDialog(this,	message.toString(),LST.V[LST.ANSWER]+" "+LST.V[LST.QUESTION]+" "+LST.V[LST.CHECK],JOptionPane.ERROR_MESSAGE);
		}
	}
	private String makeErrorString(){	//𔻒ŕ\G[bZ[W쐬
		boolean[] error=new boolean[SLError.ER_ALL];
		String[] errorMessage=new String[SLError.ER_ALL];
		errorMessage[SLError.ER_POINT_TREE]=LST.V[LST.ER_01];	//܂͌Ă
		errorMessage[SLError.ER_POINT_STOP]=LST.V[LST.ER_02];	//ĂȂ
		errorMessage[SLError.ER_CELL_LESS]=LST.V[LST.ER_03];	//̐菭Ȃ
		errorMessage[SLError.ER_CELL_OVER]=LST.V[LST.ER_04];	//̐葽
		errorMessage[SLError.ER_CELL_ANY]=LST.V[LST.ER_05];		//m̐
		errorMessage[SLError.ER_LINE_MULTI]=LST.V[LST.ER_06];	//̐
		errorMessage[SLError.ER_LINE_NONE]=LST.V[LST.ER_07];	//Ȃ
		//errorMessage[SLError.ER_NOLINE_NUMBER]="ĂȂ";	//[v1.4]Pƃ[vɁu͂ꐔvi[v1.7]Œu)
		errorMessage[SLError.ER_LINELESS_NUMBER]=LST.V[LST.ER_08];	//Ȃ	//[v1.7]Pƃ[vɁus̐v
		//}Xm
loopA:	for(int h=0;h<puzzleData.height;h++){
			for(int w=0;w<puzzleData.width;w++){
				if(puzzleData.cellNum[w][h]==SLData.CELL_ANY){
					error[SLError.ER_CELL_ANY]=true;
					break loopA;
				}
			}
		}
		//_E}X̃G[
		for(int e=0;e<puzzleData.errors.size();e++){
			switch(puzzleData.errors.get(e).type){
			case SLError.ER_POINT_TREE:
				error[SLError.ER_POINT_TREE]=true;
				break;
			case SLError.ER_POINT_STOP:
				error[SLError.ER_POINT_STOP]=true;
				break;
			case SLError.ER_CELL_LESS:
				error[SLError.ER_CELL_LESS]=true;
				break;
			case SLError.ER_CELL_OVER:
				error[SLError.ER_CELL_OVER]=true;
				break;
			}
		}
		//AE[ṽG[
		if(SLContinueLine.lineSum==0){
			error[SLError.ER_LINE_NONE]=true;
		}else if(SLContinueLine.lineSum>1){
			error[SLError.ER_LINE_MULTI]=true;
		}
		if(SLContinueLine.lineSum>SLContinueLine.loopSum){
			error[SLError.ER_POINT_STOP]=true;
		}
		/*
		if(SLContinueLine.lineSum==1 && SLContinueLine.loopSum==1 && puzzleData.checkNolineNumber()){
			error[SLError.ER_NOLINE_NUMBER]=true;	//[v1.4]Pƃ[vɁu͂ꐔvi[v1.7]Œuj
		}*/
		if(SLContinueLine.lineSum==1 && SLContinueLine.loopSum==1 && puzzleData.checkLinelessNumber()){
			error[SLError.ER_LINELESS_NUMBER]=true;	//[v1.7]Pƃ[vɁus̐v
		}
		//
		StringBuffer message=new StringBuffer();
		for(int e=0;e<SLError.ER_ALL;e++){
			if(error[e]){
				message.append(errorMessage[e]+"\n");
			}
		}
		//
		return message.toString();
	}
	/*
	 * ܂͌Ă		ER_POINT_TREE
	 * ĂȂ			ER_POINT_STOP	lineSum>loopSum
	 * ̐ 				lineSum>1
	 * ̐菭Ȃ			ER_CELL_LESS
	 * ̐葽			ER_CELL_OVER
	 * m̐			ER_CELL_ANY
	 * Ȃ					lineSum==0
	 * ĂȂ	[v1.4]Pƃ[vɁu͂ꐔvi[v1.7]Œu)
	 * Ȃ			[v1.7]Pƃ[vɁus̐v
	 */
	//-------------------------------------------------------------
	//Z[uE[h
	//-------------------------------------------------------------
	public boolean setLoadString(String[] ld){
		boolean ret=puzzleData.setLoadString(ld);
		if(ret){
			selectedCell.move(0,0);
			setPreferredPanelSize();
			//
			setChanged(false);
		}
		//
		requestFocus();	//return false ȂȂĂ
		//
		return ret;
	}
	public String getSaveString(boolean saveFlag){
		//
		requestFocus();
		//Z[upɌĂяoiAppleto͂ł͂ȂjȂ
		if(saveFlag){
			setChanged(false);
		}
		//
		return puzzleData.getSaveString();
	}
	public boolean setCSVString(String[] ld){
		boolean ret=puzzleData.setCSVString(ld);
		if(ret){
			selectedCell.move(0,0);
			setPreferredPanelSize();
			//
			setChanged(false);
		}
		//
		requestFocus();	//return false ȂȂĂ
		//
		return ret;
	}
	public String getCSVString(){
		//
		requestFocus();
		//
		return puzzleData.getCSVString();
	}
	//-------------------------------------------------------------
	//}XTCY
	//-------------------------------------------------------------
	public int getCellSize(){
		return cellSize;
	}
	public void setCellSize(int v){
		cellSize=v;
		paintRadius=calcPaintRadius(cellSize);
		//
		setPreferredPanelSize();
	}
	private int calcPaintRadius(int cell){
		if(cell>10){
			return (int)(cell/10);
		}else{
			return 1;
		}
	}
	//}XTCYύXɃt[Ă΂AꎞIɃpl̃TCY}X̃TCYɍ킹i܂t[̃TCY͕ςj
	public void adjustPanelSize(){
		//XN[o[\Ă	[XN[̈pl]<[œKplTCY]
		//Ȃ							[XN[̈pl]>[œKplTCY]
		int w=Math.max(scrollEdge.getWidth()-edgeMargin.width,getPreferredSize().width);
		int h=Math.max(scrollEdge.getHeight()-edgeMargin.height,getPreferredSize().height);
		//pl̃TCYύXiXN[̈pl傫ȂΎŃXN[o[oj
		setSize(w,h);
	}
	//-------------------------------------------------------------
	//œKTCYE`挴_̒
	//-------------------------------------------------------------
	//œKplTCYݒ
	private void setPreferredPanelSize(){
		int preferredWidth=(int)(cellSize*(puzzleData.width+ ((aroundFlag)?2.5:2) ));
		int preferredHeight=(int)(cellSize*(puzzleData.height+ ((aroundFlag)?2.5:2) ));
		setPreferredSize(new Dimension(preferredWidth,preferredHeight));
		//`挴_ݒ
		setPaintBasePoint();
	}
	//`挴_iplTCYύXPƂŌĂ΂j
	private void setPaintBasePoint(){
		//
		Dimension d=getPreferredSize();
		if(getWidth()<=d.width){
			baseX=((aroundFlag)?(cellSize>>1):0)+cellSize;
		}else{
			baseX=((aroundFlag)?(cellSize>>1):0)+cellSize+( (getWidth()-d.width)>>1 );
		}
		if(getHeight()<=d.height){
			baseY=((aroundFlag)?(cellSize>>1):0)+cellSize;
		}else{
			baseY=((aroundFlag)?(cellSize>>1):0)+cellSize+( (getHeight()-d.height)>>1 );
		}
		//ōĕ`悷̂őł͂ȂĂ
		repaint();
	}
	//œKplTCYɑ΂āApl̕\Ă镔ǂꂾTCYߏ肩Ԃ
	//it[Ă΂At[ǂꂾ߂΃XN[o[\ɂނ̔fɎgj
	public Dimension getSizeDifference(){
		//XN[o[\Ă	[pl̈]>[XN[̈pl]
		//Ȃ							[pl̈]<[XN[̈pl]
		int w=Math.min(getWidth(),scrollEdge.getWidth()-edgeMargin.width)-getPreferredSize().width;
		int h=Math.min(getHeight(),scrollEdge.getHeight()-edgeMargin.height)-getPreferredSize().height;
		return new Dimension( w , h );
	}
	//摜ۑ̂߂̕`挴_ił͕`XP[ς\̂ňČvZj
	private Dimension getOutputBasePoint(int cell){
		return new Dimension(((aroundFlag)?(cell>>1):0)+cell,((aroundFlag)?(cell>>1):0)+cell);
	}
	//-------------------------------------------------------------
	//swingɂ`惁\bh
	//-------------------------------------------------------------
	public void paintComponent(Graphics g){
		super.paintComponent(g);	//KviꂪȂƔwiFœhԂȂj
		//`挴_w肵ĕ`悳
		paintField(g,baseX,baseY,cellSize,paintRadius);
	}
	//摜ۑ̕`i`挴_͍ɋl߂WA`XP[͓j
	public void paintGraphic(Graphics g){
		Dimension base=getOutputBasePoint(cellSize);
		paintField(g, base.width, base.height,cellSize,paintRadius);
	}
	//̕`i`挴_͍ɋl߂WA`XP[͈\̈ɍ킹ďkj
	public int print(Graphics g, PageFormat fmt, int index) throws PrinterException {
		if(index>0){	//y[W1y[WɌŒ
			return NO_SUCH_PAGE;
		}else{
			//\ȍʒu
			int x=(int)fmt.getImageableX();
			int y=(int)fmt.getImageableY();
			g.translate(x,y);
			//`XP[𒲐
			double pageW=fmt.getImageableWidth();
			double pageH=fmt.getImageableHeight();
			int fieldW=getPreferredSize().width;
			int fieldH=getPreferredSize().height;
			double ratioW=pageW/fieldW;		//̔{
			double ratioH=pageH/fieldH;		//̔{
			double ratio=1;
			int cell;
			int radius;
			if(ratioW<1 || ratioH<1){		//ƍǂ炩łk̕Kv
				ratio=(ratioW<ratioH)?ratioW:ratioH;	//k˂΂ȂȂ{I
				//
				cell=(int)(cellSize*ratio);
				radius=calcPaintRadius(cell);
			}else{							//Sk̕KvȂ΂̂܂
				cell=cellSize;
				radius=paintRadius;
			}
			//
			Dimension base=getOutputBasePoint(cell);	//k`XP[Ŏ擾
			paintField(g,base.width,base.height,cell,radius);
			//
			return PAGE_EXISTS;
		}
	}
	//ėp̕`惁\bhi摜ۑɂgj
	private void paintField(Graphics g,int bx,int by,int cell,int radius){
		//n
		g.setColor(backColor);
		g.fillRect(bx-(cell>>1), by-(cell>>1), cell*(puzzleData.width+1), cell*(puzzleData.height+1));
		g.setColor(Color.BLACK);
		g.drawRect(bx-(cell>>1), by-(cell>>1), cell*(puzzleData.width+1), cell*(puzzleData.height+1));
		g.drawRect(bx-(cell>>1)+1, by-(cell>>1)+1, cell*(puzzleData.width+1)-2, cell*(puzzleData.height+1)-2);
		//͂̍sԍ
		if(aroundFlag){
			g.setFont(new Font(null,Font.BOLD | Font.ITALIC,(cell>>1)));
			for(int h=0;h<puzzleData.height+1;h++){
				g.drawString(String.valueOf(h+1), bx-(cell*3/4)-((h>=9)?(cell>>1):(cell>>2)), by+(cell>>2)+cell*h);
			}
			for(int w=0;w<puzzleData.width+1;w++){
				g.drawString(String.valueOf(w+1), bx-((w>=9)?(cell>>2):(cell>>3))+cell*w, by-(cell*3/4));
			}
		}
		//pY̐
		g.setColor(numberColor);
		g.setFont(new Font(null,Font.BOLD,cell-(cell>>2)));
		for(int h=0;h<puzzleData.height;h++){
			for(int w=0;w<puzzleData.width;w++){
				switch(puzzleData.cellNum[w][h]){
				case SLData.CELL_NONE:
					break;
				case SLData.CELL_ANY:
					g.drawString("", bx+(cell>>3)+cell*w, by-(cell>>2)+cell*(h+1));
					break;
				default:
					g.drawString(String.valueOf(puzzleData.cellNum[w][h]), bx+(cell>>2)+cell*w, by-(cell>>2)+cell*(h+1));
				}
			}
		}
		//Ɓ~
		for(int w=0;w<puzzleData.width;w++){
			for(int h=0;h<puzzleData.height;h++){
				//
				paintLineHor(w,h,g,bx,by,cell,radius);
				paintLineVer(w,h,g,bx,by,cell,radius);
			}
			//
			paintLineHor(w,puzzleData.height,g,bx,by,cell,radius);
		}
		for(int h=0;h<puzzleData.height;h++){
			//
			paintLineVer(puzzleData.width,h,g,bx,by,cell,radius);
		}
		//G[
		if(errorViewFlag){
			g.setColor(errorColor);
			for(int e=0;e<puzzleData.errors.size();e++){
				SLError error=puzzleData.errors.get(e);
				if(error.agreeCellError()){			//cell error
					g.drawString(String.valueOf(puzzleData.cellNum[error.posX][error.posY]),
							bx+(cell>>2)+cell*error.posX, by-(cell>>2)+cell*(error.posY+1));
				}else{								//point error
					if(puzzleData.getLineByPoint(error.posX, error.posY, SLData.DIR_UP)==SLData.LINE_EXIST){
						g.fillRect(bx+cell*error.posX-radius, by+cell*(error.posY-1), radius*2, cell);
					}
					if(puzzleData.getLineByPoint(error.posX, error.posY, SLData.DIR_DOWN)==SLData.LINE_EXIST){
						g.fillRect(bx+cell*error.posX-radius, by+cell*error.posY, radius*2, cell);
					}
					if(puzzleData.getLineByPoint(error.posX, error.posY, SLData.DIR_LEFT)==SLData.LINE_EXIST){
						g.fillRect(bx+cell*(error.posX-1), by+cell*error.posY-radius, cell, radius*2);
					}
					if(puzzleData.getLineByPoint(error.posX, error.posY, SLData.DIR_RIGHT)==SLData.LINE_EXIST){
						g.fillRect(bx+cell*error.posX, by+cell*error.posY-radius, cell, radius*2);
					}
				}
			}
		}
		//_
		if(gridFlag){
			g.setColor(gridColor);
			for(int h=0;h<puzzleData.height+1;h++){
				for(int w=0;w<puzzleData.width+1;w++){
					g.fillOval(bx+cell*w-radius, by+cell*h-radius, radius*2, radius*2);
				}
			}
		}
		//ҏW[h̑I}X
		if(puzzleMode==MODE_EDIT){
			g.setColor(Color.RED);
			g.drawRect(bx+cell*selectedCell.x, by+cell*selectedCell.y, cell, cell);
			g.drawRect(bx+cell*selectedCell.x+1, by+cell*selectedCell.y+1, cell-2, cell-2);
		}
	}
	//`
	private void paintLineHor(int w,int h,Graphics g,int bx,int by,int cell,int radius){
		switch( puzzleData.lineHor[w][h] ){
		case SLData.LINE_EXIST:
			if(paintLineFlag){
				g.setColor(puzzleData.getHorLineColor(w,h));
			}else{
				g.setColor(lineColor);
			}
			g.fillRect(bx+cell*w, by+cell*h-radius, cell, radius*2);
			break;
		case SLData.LINE_NONE:
			g.setColor(crossColor);
			paintCross(bx+(cell>>1)+cell*w,by+cell*h,g,radius);
			break;
		}
	}
	private void paintLineVer(int w,int h,Graphics g,int bx,int by,int cell,int radius){
		switch( puzzleData.lineVer[w][h] ){
		case SLData.LINE_EXIST:
			if(paintLineFlag){
				g.setColor(puzzleData.getVerLineColor(w,h));
			}else{
				g.setColor(lineColor);
			}
			g.fillRect(bx+cell*w-radius, by+cell*h, radius*2, cell);
			break;
		case SLData.LINE_NONE:
			g.setColor(crossColor);
			paintCross(bx+cell*w,by+(cell>>1)+cell*h,g,radius);
			break;
		}
	}
	//~`
	private void paintCross(int x,int y,Graphics g,int radius){
		g.drawLine(x-radius*2, y-radius*2, x+radius*2, y+radius*2);
		g.drawLine(x-radius*2-1, y-radius*2, x+radius*2-1, y+radius*2);
		g.drawLine(x+radius*2, y-radius*2, x-radius*2, y+radius*2);
		g.drawLine(x+radius*2-1, y-radius*2, x-radius*2-1, y+radius*2);
	}
	//-------------------------------------------------------------
	//}EXCxg
	//-------------------------------------------------------------
	public void mouseClicked(MouseEvent e) {
		Point containPointArea=getContainPointArea(e.getX(),e.getY());
		if(containPointArea==null){		return;		}	//pYO
		//
		int dx=e.getX()-(baseX+cellSize*containPointArea.x);
		int dy=e.getY()-(baseY+cellSize*containPointArea.y);
		int dir=getDirection(dx,dy);
		//ύX
		changeLine(containPointArea,dir,e);
	}
	public void mouseEntered(MouseEvent arg0) {
	}
	public void mouseExited(MouseEvent e) {
		draggedPointArea=null;
	}
	public void mousePressed(MouseEvent e) {
		//V_̈ݒiύX͂Ȃj
		draggedPointArea=getContainPointArea(e.getX(),e.getY());
	}
	public void mouseReleased(MouseEvent e) {
		draggedPointArea=null;
	}
	public void mouseDragged(MouseEvent e) {
		//|C^̓_̈悪ςĂΐύX
		Point containPointArea=getContainPointArea(e.getX(),e.getY());
		if(containPointArea==null || draggedPointArea==null){	//ړ̓pYł͂Ȃ
			draggedPointArea=containPointArea;
			return;
		}
		//
		if(!containPointArea.equals(draggedPointArea)){
			int dir;
			if(containPointArea.x>draggedPointArea.x){
				dir=SLData.DIR_RIGHT;
			}else if(containPointArea.x<draggedPointArea.x){
				dir=SLData.DIR_LEFT;
			}else if(containPointArea.y>draggedPointArea.y){
				dir=SLData.DIR_DOWN;
			}else/* if(containPointArea.y<draggedPointArea.y)*/{
				dir=SLData.DIR_UP;
			}
			//ύX
			changeLine(draggedPointArea,dir,e);
			//V_̈
			draggedPointArea=containPointArea;
		}
	}
	public void mouseMoved(MouseEvent e) {
	}
	//ύXiE{^܂̓VtgL[ł́~j
	private void changeLine(Point p,int d,MouseEvent e){
		if(e.getModifiers()==MouseEvent.META_MASK || e.isShiftDown()){
			if(puzzleData.getLineByPoint(p.x, p.y, d)==SLData.LINE_NONE){
				puzzleData.setLineByPoint(p.x, p.y, d, SLData.LINE_BLANK);
			}else{
				puzzleData.setLineByPoint(p.x, p.y, d, SLData.LINE_NONE);
			}
		}else{
			if(puzzleData.getLineByPoint(p.x, p.y, d)==SLData.LINE_EXIST){
				puzzleData.setLineByPoint(p.x, p.y, d, SLData.LINE_BLANK);
			}else{
				puzzleData.setLineByPoint(p.x, p.y, d, SLData.LINE_EXIST);
			}
		}
		//pYf[^ύX
		setChanged(true);
		//
		repaint();
	}
	//w̃xNg͂ǂ̕Ă邩
	private int getDirection(int dx,int dy){
		if(dx>=0){
			if(dy>=0){
				if(Math.abs(dx)>=Math.abs(dy)){
					return SLData.DIR_RIGHT;
				}else{
					return SLData.DIR_DOWN;
				}
			}else{
				if(Math.abs(dx)>=Math.abs(dy)){
					return SLData.DIR_RIGHT;
				}else{
					return SLData.DIR_UP;
				}
			}
		}else{
			if(dy>=0){
				if(Math.abs(dx)>=Math.abs(dy)){
					return SLData.DIR_LEFT;
				}else{
					return SLData.DIR_DOWN;
				}
			}else{
				if(Math.abs(dx)>=Math.abs(dy)){
					return SLData.DIR_LEFT;
				}else{
					return SLData.DIR_UP;
				}
			}
		}
	}
	//̃|C^ʒu͂ǂ̓_̈Ɋ܂܂邩
	private Point getContainPointArea(int x,int y){
		if(checkContain(x,y)){
			Point ret=new Point();
			ret.x=(int)( (x- (baseX-(cellSize>>1)) )/cellSize );
			ret.y=(int)( (y- (baseY-(cellSize>>1)) )/cellSize );
			return ret;
		}else{
			return null;
		}
	}
	//̃|C^ʒu̓pYɊ܂܂邩
	private boolean checkContain(int x,int y){
		if( x>=baseX-(cellSize>>1) && x<baseX-(cellSize>>1)+cellSize*(puzzleData.width+1) &&
				y>=baseY-(cellSize>>1) && y<baseY-(cellSize>>1)+cellSize*(puzzleData.height+1) ){
			return true;
		}else{
			return false;
		}
	}
	//-------------------------------------------------------------
	//L[Cxg
	//-------------------------------------------------------------
	public void keyReleased(KeyEvent e) {
	}
	public void keyTyped(KeyEvent e) {
	}
	public void keyPressed(KeyEvent e) {
		if(puzzleMode!=MODE_EDIT){
			return;		//ҏW[ĥ
		}
		//
		switch(e.getKeyCode()){
		//ҏW[h̃}Xړ
		case KeyEvent.VK_UP:
			if(selectedCell.y>0){
				selectedCell.y-=1;
				repaint();
			}
			break;
		case KeyEvent.VK_DOWN:
			if(selectedCell.y<puzzleData.height-1){
				selectedCell.y+=1;
				repaint();
			}
			break;
		case KeyEvent.VK_RIGHT:
			if(selectedCell.x<puzzleData.width-1){
				selectedCell.x+=1;
				repaint();
			}
			break;
		case KeyEvent.VK_LEFT:
			if(selectedCell.x>0){
				selectedCell.x-=1;
				repaint();
			}
			break;
		//}XύX
		case KeyEvent.VK_0:
		case KeyEvent.VK_NUMPAD0:
			changeCell(selectedCell, 0);
			break;
		case KeyEvent.VK_1:
		case KeyEvent.VK_NUMPAD1:
			changeCell(selectedCell, 1);
			break;
		case KeyEvent.VK_2:
		case KeyEvent.VK_NUMPAD2:
			changeCell(selectedCell, 2);
			break;
		case KeyEvent.VK_3:
		case KeyEvent.VK_NUMPAD3:
			changeCell(selectedCell, 3);
			break;
		case KeyEvent.VK_SPACE:
			changeCell(selectedCell, SLData.CELL_NONE);
			break;
		case KeyEvent.VK_MINUS:
		case KeyEvent.VK_SUBTRACT:
			changeCell(selectedCell, SLData.CELL_ANY);
			break;
		}
	}
	//}XύX
	private void changeCell(Point p,int v){
		puzzleData.setCell(p, v);
		//pYf[^ύX
		setChanged(true);
		//
		repaint();
	}
	//-------------------------------------------------------------
	//R|[lgCxgitB[h̑傫ύX擾j
	//-------------------------------------------------------------
	public void componentHidden(ComponentEvent arg0) {
	}
	public void componentMoved(ComponentEvent arg0) {
	}
	//pl̃TCYςΕ`挴_Đݒ
	public void componentResized(ComponentEvent e) {
		setPaintBasePoint();
	}
	public void componentShown(ComponentEvent arg0) {
	}
}
